/*******************************************************************************

File:   AlimFunc.c
Author : Luca Tanganelli (shinshi)
Version : 1.0

Created on Date : 31/03/2013
Last update     : 10/08/2013

CopyRight 2013 all rights are reserved

********************************************************
SOFTWARE LICENSE AGREEMENT
********************************************************

The usage of the supplied software imply the acceptance of the following license.

The software supplied herewith by Luca Tanganelli (the Author) is intended for
use solely and exclusively on Microchip PIC Microcontroller (registered mark).
The software is owned by the Author, and is protected under applicable
copyright laws. All rights are reserved.
Any use in violation of the foregoing restrictions may subject the
user to criminal sanctions under applicable laws, as well as to civil liability
for the breach of the terms and conditions of this license.
Commercial use is forbidden without a written acknowledgment with the Author.
Personal or educational use is allowed if the application containing the
following software doesn't aim to commercial use or monetary earning of any kind.

THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE AUTHOR SHALL NOT,
IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

*******************************************************************************/
#include "AlimFunc.h"

//******************************************************************************
//                  rounding Implementation
//******************************************************************************
int rounding (int value, char shift){
    int valround; //valore arrotondato di ritorno
    char digit; //singolo digit isolato
    char prevround; //in un precedente arrotondamento abbiamo perso una parte
    char over=0; //si deve aumentare il prossimo digit
    
    while (shift){
            if (value==0){//se value diventa 0...
                    break;//termina funzione e ritorna 0
            }
            valround = value / 10; //shift a destra di 1 digit
            digit = value - (valround * 10); //isolo il digit eliminato
            if (digit==5){ //se il digit un 5...
                    if (prevround==1){ //e se precedentemente ho perso parte del numero...
                            over=1; //allora devo incrementare di uno il valore arrotondato
                            prevround=0; //azzero la variabile in quanto ho recuperato pa perdita precedente
                    }else{ //se invece precedentemento non ho perso parte del numero..
                            prevround=1; //allora mi devo ricordare che perdo questo digit
                    }
            }
            if (digit>5){ //se il digit  maggiore di 5..
                    over=1; //allora devo incrementare di uno il valore arrotondato
            }
            if ((digit<5) && (digit!=0)){ //se il digit  minore di 5 e non 0...
                    prevround=1;//allora mi devo ricordare che perdo questo digit
            }
            value = valround + over;//sommo l'incremento al valore
            over=0;//azzero l'incremento
            shift--;//passo al prossimo shift
    }
    
    return (value);
}

//************************************************************
//                  write_decimal_LCD  Implementation
//************************************************************
void write_decimal_LCD(int value, char number_of_digits, char number_of_decimals){

    char number=0; //Flag per indicare che un digit  un numero

	char comma; //posizione dalle virgola

    unsigned char convertedInt [7]; // Lunghezza dell'array  di 6 pi la fine della stringa

    // Index used to shift to the right the digit
    char index;

	//calcolo posizione virgola nell'array
	comma = number_of_digits-number_of_decimals-1;

    // Integer is converted to string
    itoa (value, (char*) convertedInt);


    convertedInt[number_of_digits] = '\0';

    // Shift the digit to the right removing the empty one
	while (!(convertedInt[number_of_digits-1] <= '9' && convertedInt[number_of_digits-1] >= '0')){

		for (index = number_of_digits-1; index > 0; index--){
				convertedInt[index] = convertedInt[index-1];
				convertedInt[index-1] = ' ';
		}
	}

    if (number_of_decimals){
		// Posiziono la virgola
		for (index = 1; index < number_of_digits-1; index++){
			number=isdigit(convertedInt[index]);
			//se  prima della virgola...
			if (index < comma){
				convertedInt[index-1] = convertedInt[index];
			}
			//se  la posizione della virgola...
			if (index == comma){
				if (!number){
					convertedInt[index] = '0';
				}
				convertedInt[index-1] = convertedInt[index];
				convertedInt[index] = ',';
			}
			//se  dopo la virgola...
			if (index > comma){
				if (!number){
					convertedInt[index] = '0';
				}
			}
		}
    }
    write_string_LCD (convertedInt); //scrive la stringa risultante nell'LCD

}

//************************************************************
//                  offsetting  Implementation
//************************************************************
char offsetting(int pot, int read, char comp){
        // il potenziometro non deve essere hai limiti estremi
        if (pot > 3 && pot < 1020){
            // se il il vapore del potenziometro  minore del vaore in uscita
            // e non  gi al minimo...
            if (pot < read && comp > -3){
                // allora decrementa la compensazione
                comp--;
            }
            // se il il vapore del potenziometro  maggiore del vaore in uscita
            // e non  gi al massimo...
            if (pot > read && comp < 3){
                // allora incrementa la compensazione
                comp++;
            }
        // se invece siamo agli estremi azzera la compensazione per non eccedere
        //i limiti
        }else{
            comp = 0;
        }
        return comp;
}

//************************************************************
//                  pot2pwm  Implementation
//************************************************************
int pot2pwm (int raw_pot, char comp){
    return (((short long) raw_pot * 1003) >> 10)+comp;
}